// neterrimpl.cpp
// The implementation file for NetErr Library

#include "stdafx.h"
#include "neterr.h"

NetErrAPI BOOL CALLTYPE
neterrIsDescriptionAvailable( int nErrorCode )
{
	char szTest[ 1024 ];
	return ::neterrGetDescriptionCompleteA( nErrorCode, szTest, 1024 );
}

NetErrAPI int CALLTYPE
neterrGetLastError( VOID )
{
	return ::WSAGetLastError();
}

NetErrAPI VOID CALLTYPE
neterrSetLastError( int nErrorCode )
{
	::WSASetLastError( nErrorCode );
}

NetErrAPI BOOL CALLTYPE
neterrGetDescriptionCompleteA( int nErrorCode, LPSTR pszDescription, DWORD cchDescription )
{
	int nBytes = ::LoadStringA( (HINSTANCE) ::g_hDllInstance, (UINT) nErrorCode,
		pszDescription, cchDescription );

	return nBytes > 0;
}

NetErrAPI BOOL CALLTYPE
neterrGetDescriptionCompleteW( int nErrorCode, LPWSTR pwszDescription, DWORD cchDescription )
{
	int nBytes = ::LoadStringW( (HINSTANCE) ::g_hDllInstance, (UINT) nErrorCode,
		pwszDescription, cchDescription );

	return nBytes > 0;
}

NetErrAPI BOOL CALLTYPE
neterrGetDescriptionTitleA( int nErrorCode, LPSTR pszTitle, DWORD cchTitle )
{
	CHAR szComplete [ 1024 ]; // 1KB is sufficient

	if (!::neterrGetDescriptionCompleteA( nErrorCode, szComplete, 1024 ))
		return FALSE;

	int i = 0;
	bool bFound = false;

	while (szComplete[ i ])
	{
		if (szComplete[ i ] == ' ' &&
			szComplete[ i + 1 ] && szComplete[ i + 1 ] == '-' &&
			szComplete[ i + 2 ] && szComplete[ i + 2 ] == ' ')
		{
			bFound = true;
			break;
		}

		++ i;
	}

	if (!bFound)
	{
		return FALSE;
	}
	else
	{
		szComplete[ i ] = '\0';

		if (cchTitle < (DWORD) ::lstrlenA( szComplete ))
		{
			::SetLastError( ERROR_INSUFFICIENT_BUFFER );
			return FALSE;
		}

		::lstrcpyA( pszTitle, szComplete );
	}

	return TRUE;
}

NetErrAPI BOOL CALLTYPE
neterrGetDescriptionTitleW( int nErrorCode, LPWSTR pwszTitle, DWORD cchTitle )
{
	WCHAR wszComplete [ 1024 ]; // 1KB is sufficient

	if (!::neterrGetDescriptionCompleteW( nErrorCode, wszComplete, 1024 ))
		return FALSE;

	int i = 0;
	bool bFound = false;

	while (wszComplete[ i ])
	{
		if (wszComplete[ i ] == L' ' &&
			wszComplete[ i + 1 ] && wszComplete[ i + 1 ] == L'-' &&
			wszComplete[ i + 2 ] && wszComplete[ i + 2 ] == L' ')
		{
			bFound = true;
			break;
		}

		++ i;
	}

	if (!bFound)
	{
		return FALSE;
	}
	else
	{
		wszComplete[ i ] = L'\0';

		if (cchTitle < (DWORD) ::lstrlenW( wszComplete ))
		{
			::SetLastError( ERROR_INSUFFICIENT_BUFFER );
			return FALSE;
		}

		::lstrcpyW( pwszTitle, wszComplete );
	}

	return TRUE;
}


NetErrAPI BOOL CALLTYPE
neterrGetDescriptionShortA( int nErrorCode, LPSTR pszShort, DWORD cchShort )
{
	CHAR szComplete [ 1024 ];

	if (!::neterrGetDescriptionCompleteA( nErrorCode, szComplete, 1024 ))
		return FALSE;

	int i = 0;
	bool bFound = true;

	while (szComplete[ i ])
	{
		if (szComplete[ i ] == ' ' &&
			szComplete[ i + 1 ] && szComplete[ i + 1 ] == '-' &&
			szComplete[ i + 2 ] && szComplete[ i + 2 ] == ' ')
		{
			bFound = true;
			break;
		}

		++ i;
	}

	if (!bFound)
	{
		return FALSE;
	}
	else
	{
		i += 3;
		CHAR * pszComplete = &szComplete[ i ];

		if (cchShort < (DWORD) ::lstrlenA( pszComplete ))
		{
			::SetLastError( ERROR_INSUFFICIENT_BUFFER );
			return FALSE;
		}

		::lstrcpyA( pszShort, pszComplete );
	}

	return TRUE;
}

NetErrAPI BOOL CALLTYPE
neterrGetDescriptionShortW( int nErrorCode, LPWSTR pwszShort, DWORD cchShort )
{
	WCHAR wszComplete [ 1024 ];

	if (!::neterrGetDescriptionCompleteW( nErrorCode, wszComplete, 1024 ))
		return FALSE;

	int i = 0;
	bool bFound = true;

	while (wszComplete[ i ])
	{
		if (wszComplete[ i ] == L' ' &&
			wszComplete[ i + 1 ] && wszComplete[ i + 1 ] == L'-' &&
			wszComplete[ i + 2 ] && wszComplete[ i + 2 ] == L' ')
		{
			bFound = true;
			break;
		}

		++ i;
	}

	if (!bFound)
	{
		return FALSE;
	}
	else
	{
		i += 3;
		WCHAR * pwszComplete = &wszComplete[ i ];

		if (cchShort < (DWORD) ::lstrlenW( pwszComplete ))
		{
			::SetLastError( ERROR_INSUFFICIENT_BUFFER );
			return FALSE;
		}

		::lstrcpyW( pwszShort, pwszComplete );
	}

	return TRUE;
}